var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var TypeContainer_1 = require("../TypeContainer");
var EwsLogging_1 = require("../Core/EwsLogging");
var ComplexPropertyCollection_1 = require("./ComplexPropertyCollection");
/**
 * Represents an item's attachment collection.
 */
var AttachmentCollection = (function (_super) {
    __extends(AttachmentCollection, _super);
    /**
     * Initializes a new instance of AttachmentCollection.
     */
    function AttachmentCollection() {
        _super.call(this);
        this.___implementsInterface = ["IOwnedProperty", "ISelfValidate", "IJsonSerializable", "IEnumerable<TComplexProperty>", "ICustomUpdateSerializer", "IJsonCollectionDeserialize"];
        this.___typeName = "Attachment";
        this.___typeGenerics = ["ComplexProperty"];
    }
    Object.defineProperty(AttachmentCollection.prototype, "Owner", {
        get: function () { return this.owner; },
        set: function (value) {
            EwsLogging_1.EwsLogging.Assert(value != null && !(value instanceof TypeContainer_1.TypeContainer.Item), "AttachmentCollection.IOwnedProperty.set_Owner", "value is not a descendant of ItemBase");
            this.owner = value;
        },
        enumerable: true,
        configurable: true
    });
    ;
    /**
     * Adds a file attachment to the collection.
     *
     * @param   {[string]}	fileName   The name of the file representing the content of the attachment.
     * @return  {[FileAttachment]} 		A FileAttachment instance.
     */
    AttachmentCollection.prototype.AddFileAttachment = function (fileName) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - AddFileAttachment : Not implemented."); return null; };
    //AddFileAttachment(name: string, fileName: string): FileAttachment{ throw new Error("AttachmentCollection.ts - AddFileAttachment : Not implemented.");}
    //AddFileAttachment(name: string, contentStream: any /*System.IO.Stream*/): FileAttachment{ throw new Error("AttachmentCollection.ts - AddFileAttachment : Not implemented.");}
    //AddFileAttachment(name: string, content: any /*System.Byte[]*/): FileAttachment{ throw new Error("AttachmentCollection.ts - AddFileAttachment : Not implemented.");}
    AttachmentCollection.prototype.AddItemAttachment = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - AddItemAttachment<TItem extends Item> : Not implemented."); return null; };
    AttachmentCollection.prototype.Clear = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - Clear : Not implemented."); };
    AttachmentCollection.prototype.ClearChangeLog = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - ClearChangeLog : Not implemented."); };
    AttachmentCollection.prototype.CreateComplexProperty = function (xmlElementName) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - CreateComplexProperty : Not implemented."); return null; };
    AttachmentCollection.prototype.CreateDefaultComplexProperty = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - CreateDefaultComplexProperty : Not implemented."); return null; };
    AttachmentCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - GetCollectionItemXmlElementName : Not implemented."); return null; };
    AttachmentCollection.prototype.HasUnprocessedChanges = function () { EwsLogging_1.EwsLogging.Assert(true, "AttachmentCollection.ts - HasUnprocessedChanges :", "Not implemented."); return false; };
    AttachmentCollection.prototype.InternalCreateAttachments = function (parentItemId, attachments /*System.Collections.Generic.IEnumerable<Attachment>*/) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - InternalCreateAttachments : Not implemented."); };
    AttachmentCollection.prototype.InternalDeleteAttachments = function (attachments /*System.Collections.Generic.IEnumerable<Attachment>*/) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - InternalDeleteAttachments : Not implemented."); };
    AttachmentCollection.prototype.Remove = function (attachment) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - Remove : Not implemented."); return null; };
    AttachmentCollection.prototype.RemoveAt = function (index) { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - RemoveAt : Not implemented."); };
    AttachmentCollection.prototype.Save = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - Save : Not implemented."); };
    AttachmentCollection.prototype.Validate = function () { EwsLogging_1.EwsLogging.DebugLog("AttachmentCollection.ts - Validate : Not implemented."); };
    return AttachmentCollection;
})(ComplexPropertyCollection_1.ComplexPropertyCollection);
exports.AttachmentCollection = AttachmentCollection;
