var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var ItemSchema_1 = require("../Schemas/ItemSchema");
var EmailMessageSchema_1 = require("../Schemas/EmailMessageSchema");
var CalendarResponseObjectSchema_1 = require("../Schemas/CalendarResponseObjectSchema");
var CalendarResponseMessageBase_1 = require("./CalendarResponseMessageBase");
/**
 * Represents the base class for accept, tentatively accept and decline response messages.
 */
var CalendarResponseMessage = (function (_super) {
    __extends(CalendarResponseMessage, _super);
    /**
     * Initializes a new instance of the  class.
     *
     * @param   {[Item]}   referenceItem   The reference item.
     */
    function CalendarResponseMessage(referenceItem) {
        _super.call(this, referenceItem);
    }
    Object.defineProperty(CalendarResponseMessage.prototype, "Body", {
        /**
         * Gets or sets the body of the response.
         */
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Body);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Body, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "ToRecipients", {
        /**
         * Gets a list of recipients the response will be sent to.
         */
        get: function () {
            return this.PropertyBag._getItem(EmailMessageSchema_1.EmailMessageSchema.ToRecipients);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "CcRecipients", {
        /**
         * Gets a list of recipients the response will be sent to as Cc.
         */
        get: function () {
            return this.PropertyBag._getItem(EmailMessageSchema_1.EmailMessageSchema.CcRecipients);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "BccRecipients", {
        /**
         * Gets a list of recipients this response will be sent to as Bcc.
         */
        get: function () {
            return this.PropertyBag._getItem(EmailMessageSchema_1.EmailMessageSchema.BccRecipients);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "ItemClass", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ItemClass);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.ItemClass, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "Sensitivity", {
        /**
         * Gets or sets the sensitivity of this response.
         */
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Sensitivity);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Sensitivity, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "Attachments", {
        /**
         * Gets a list of attachments to this response.
         */
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Attachments);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "InternetMessageHeaders", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.InternetMessageHeaders);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarResponseMessage.prototype, "Sender", {
        /**
         * Gets or sets the sender of this response.
         */
        get: function () {
            return this.PropertyBag._getItem(EmailMessageSchema_1.EmailMessageSchema.Sender);
        },
        set: function (value) {
            this.PropertyBag._setItem(EmailMessageSchema_1.EmailMessageSchema.Sender, value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Internal method to return the schema associated with this type of object.
     *
     * @return  {[ServiceObjectSchema]}      The schema associated with this type of object.
     */
    CalendarResponseMessage.prototype.GetSchema = function () {
        return CalendarResponseObjectSchema_1.CalendarResponseObjectSchema.Instance;
    };
    return CalendarResponseMessage;
})(CalendarResponseMessageBase_1.CalendarResponseMessageBase);
exports.CalendarResponseMessage = CalendarResponseMessage;
